<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>task 26.10 Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody id="tbody-order">

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gEND_OF_ROW_COL = -1;//dòng cuối hay cột cuối
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
             /**
            * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
            */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpGetAllOrders.responseText);
                    var vAllOrder=JSON.parse(vXmlHttpGetAllOrders.responseText);
                    loadOrderToTable(vAllOrder);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vElementTBody=document.getElementById("tbody-order");
        for (var bI=0; bI<paramAllOrder.length; bI++){
        //thêm 1 dòng mới bằng thẻ <tr>
          var bNewRow=vElementTBody.insertRow(gEND_OF_ROW_COL);
          //thêm các ô trên dòng mới
          var bOrderCodeCell=bNewRow.insertCell(0);
          var bKichCoComboCell=bNewRow.insertCell(1);
          var bLoaiPizzaCell=bNewRow.insertCell(2);
          var bNuocUongboCell=bNewRow.insertCell(3);
          var bThanhTienCell=bNewRow.insertCell(4);
          var bHoTenCell=bNewRow.insertCell(5);
          var bSoDienThoaiCell=bNewRow.insertCell(6);
          var bTrangThaiCell=bNewRow.insertCell(7);
          var bChiTietCell=bNewRow.insertCell(8);
            //điền dữ liệu cho từng ô
            bOrderCodeCell.innerHTML=paramAllOrder[bI].orderCode;
            bKichCoComboCell.innerHTML=paramAllOrder[bI].kichCo;
            bLoaiPizzaCell.innerHTML=paramAllOrder[bI].loaiPizza;
            bNuocUongboCell.innerHTML=paramAllOrder[bI].idLoaiNuocUong;
            bThanhTienCell.innerHTML=paramAllOrder[bI].thanhTien;
            bHoTenCell.innerHTML=paramAllOrder[bI].hoTen;
            bSoDienThoaiCell.innerHTML=paramAllOrder[bI].soDienThoai;
            bTrangThaiCell.innerHTML=paramAllOrder[bI].trangThai;
            bChiTietCell.innerHTML="<button class='btn btn-info' onclick='onBtnDetailClick(this)' data-id='"
            +paramAllOrder[bI].id
            +"' data-ordercode='"+paramAllOrder[bI].orderCode+"' >Chi Tiết</button>";
        // var bButtonDetail=document.getElementById("btn-detail");
        // bButtonDetail.setAttribute("data-id", paramAllOrder[bI].id);
        // bButtonDetail.setAttribute("data-ordercode", paramAllOrder[bI].orderCode);
        
        // bButtonDetail.addEventListener("click", function (){
        //     onBtnDetailClick(this);
        //}
        //);
        //bButtonDetail.setAttribute("onclick",'onBtnDetailClick(this)');
        }
        }
     function onBtnDetailClick(paramButtonDetailClick){
       
         var  vId=paramButtonDetailClick.dataset.id;
       var  vOrderCode=paramButtonDetailClick.dataset.ordercode;
        console.log("Id là: "+ vId);
        console.log("OrderCode là: "+vOrderCode);
        const gOrderForm_Url="OrderForm.html";
        var vUrlSiteOpen=gOrderForm_Url+"?"+"id="+vId + "&ordercode="+vOrderCode;
        window.location.href=vUrlSiteOpen;
     }   
    </script>
</body>

</html>